#r "System.Windows.Forms"
using System.Windows.Forms;
using System.Linq;
using System.Resources;
using System.IO;

string resxPath = Path.Combine(Path.GetDirectoryName(ScriptFilePath), Application.Settings.LanguageCode == "ja" ? "Resources.ja.resx" : "Resources.resx");
ResXResourceSet resx = new ResXResourceSet(resxPath);

var node = Application.DrawingBar.SelectedNode;
if(node == null || node.Drawing == null || !(node.Drawing is Paper))
{
    MessageBox.Show(resx.GetString("ConfirmMessage1"));
    return;
}

// }c[EBhEőIĂp擾܂B
Paper selectedPaper = (Paper)node.Drawing;

// ǉp̖ÓA̗p̌ (2) t܂B
int n = 2;
while(ActiveDocument.Drawings.Any(drawing => drawing.Name == n.ToString(selectedPaper.Name + " (0)")))
    n++;

// UNDO Jn܂B
ActiveDocument.UndoManager.BeginUndoUnit();

// Vpǉ܂B
Paper newPaper = ActiveDocument.Drawings.AddPaper(n.ToString(selectedPaper.Name + " (0)"));

// p̃vpeBRs[܂B
newPaper.State = selectedPaper.State;
newPaper.Landscape = selectedPaper.Landscape;
newPaper.PaperType = selectedPaper.PaperType;
if(selectedPaper.PaperType == PaperType.Custom)
{
    newPaper.PaperWidth = selectedPaper.PaperWidth;
    newPaper.PaperHeight = selectedPaper.PaperHeight;
}
newPaper.Printable = selectedPaper.Printable;
newPaper.PrintScale = selectedPaper.PrintScale;
newPaper.UserOrigin = selectedPaper.UserOrigin;

// ObhݒRs[
newPaper.GridSettings.AngleX = selectedPaper.GridSettings.AngleX;
newPaper.GridSettings.AngleY = selectedPaper.GridSettings.AngleY;
newPaper.GridSettings.Color = selectedPaper.GridSettings.Color;
newPaper.GridSettings.Enabled = selectedPaper.GridSettings.Enabled;
newPaper.GridSettings.EnableGridBounds = selectedPaper.GridSettings.EnableGridBounds;
newPaper.GridSettings.GridType = selectedPaper.GridSettings.GridType;
newPaper.GridSettings.Origin = selectedPaper.GridSettings.Origin;
newPaper.GridSettings.SpaceX = selectedPaper.GridSettings.SpaceX;
newPaper.GridSettings.SpaceY = selectedPaper.GridSettings.SpaceY;
newPaper.GridSettings.Unit = selectedPaper.GridSettings.Unit;
newPaper.GridSettings.UnitColor = selectedPaper.GridSettings.UnitColor;
if(selectedPaper.GridSettings.EnableGridBounds)
{
    newPaper.GridSettings.SetGridBounds(
        selectedPaper.GridSettings.GridBoundsBottomLeft,
        selectedPaper.GridSettings.GridBoundsTopRight);
}

// UNDO I܂B
ActiveDocument.UndoManager.EndUndoUnit();
